use crate::config::config::Config;
use crate::store::ignorer::Ignorer;
// use crate::store::object::object::{Obj, ObjMethods};
// use crate::store::{self, object::Object};
// use crate::utils::nextsyncignore::{self, ignore_file};
// use crate::utils::path::{normalize_relative, path_buf_to_string, repo_root};
// use crate::utils::{self, path};
// use glob::glob;
use std::path::{Path, PathBuf};

pub struct AddArgs {
    /// List of files/dirs to add
    pub files: Vec<String>,
    /// Allow ignored files
    pub force: bool,
    /// Select all files
    pub all: bool,
}

pub fn exec(args: AddArgs, config: Config) {
    // Init ignorer
    let mut ignorer = Ignorer::new(config.get_root_unsafe());
    ignorer.active_nsignore(!args.force);

    if args.all {
        return add_dir(config.get_root_unsafe(), &mut ignorer);
    }

    /*
       for all files
           if globbing
               take all match glob nextsyncignore
           else
               if dir
                   add dir
                   add all childs with nextsyncignore
               else
                   add files
    */
}

/// Add all files in a directory
///
/// # Parameters
/// * `dir`: the directory to add from
/// * `force`: true if we should apply the nextsyncignore's rules
fn add_dir(dir: &PathBuf, ignorer: &mut Ignorer) {
    /*
    for elements present in dir {
        if !force && should_ignore() {
            continue;
        }
        if is dir
            add_dir(new_dir, force)
        else

    }
    */
}
